export class Main extends Indicator {

    constructor() {
        super();

        this.setProperty(Property.SeparateWindow, true);

        this.addInput("CCIPeriod", InputType.int, 14, {
            min : 1,
        });
        this.addInput("PriceType", InputType.PriceType, PriceType.Bid);

        this.buffers = {
            CCIBuffer : this.addBuffer()
        };
    }

    onInit() {
        let {CCIPeriod} = this.getInputs();

        this.buffers.CCIBuffer
            .setShape(Shape.Line)
            .setColor(Color.LightSeaGreen)
            .setLabel("CCI(" + CCIPeriod + ")")
            .setShortName("CCI(" + CCIPeriod + ")")
            .setDrawBegin(CCIPeriod)
        ;
    }

    async onUpdate() {
        const  {CCIPeriod, PriceType} = this.getInputs(),
                {CCIBuffer} = this.buffers;

        let list = await Indicators.CCI(null, 0, CCIPeriod, AppliedPrice.Typical, PriceType);
        CCIBuffer.fill(list);
    }
}